'use strict';

var logger = require('./logger')(module);
var Promise = require('bluebird');

module.exports = function assertDatabase(q) {
  logger('assertDatabase');
  return Promise.resolve().then(function () {
    return q.r.dbList().contains(q.db).do(function (databaseExists) {
      return q.r.branch(databaseExists, { dbs_created: 0 }, q.r.dbCreate(q.db));
    }).run(q.queryRunOptions);
  }).then(function (dbCreateResult) {
    dbCreateResult.dbs_created > 0 ? logger('Database created: ' + q.db) : logger('Database exists: ' + q.db);
    return true;
  });
};