'use strict';

var logger = require('./logger')(module);
var Promise = require('bluebird');
var enums = require('./enums');
var queueDb = require('./queue-db');
var queueStop = require('./queue-stop');

module.exports = function queueDrop(q) {
  logger('queueDrop');
  return queueStop(q).then(function () {
    q._ready = Promise.resolve(false);
    return queueDb.detach(q);
  }).then(function () {
    return q.r.db(q.db).tableDrop(q.name).run(q.queryRunOptions);
  }).then(function () {
    logger('Event: dropped [' + q.id + ']');
    q.emit(enums.status.dropped, q.id);
    return queueDb.drain(q);
  });
};