'use strict';

var logger = require('./logger')(module);
var Promise = require('bluebird');
var enums = require('./enums');
var dbResult = require('./db-result');

module.exports = function queueFindJobByName(q, name, raw) {
  logger('queueFindJobByName: ', name, raw);
  return Promise.resolve().then(function () {
    return q.r.db(q.db).table(q.name).getAll(name, { index: enums.index.indexName }).orderBy('dateCreated').run(q.queryRunOptions);
  }).then(function (jobsData) {
    logger('jobsData', jobsData);
    if (raw) {
      return jobsData;
    }
    return dbResult.toJob(q, jobsData);
  });
};