'use strict';

var logger = require('./logger')(module);
var enums = require('./enums');

module.exports = function queueState(q, newState) {
  logger('queueState', newState);
  return q.ready().then(function () {
    return q.r.db(q.db).table(q.name).insert({
      id: enums.state.docId,
      queueId: q.id,
      dateChange: q.r.now(),
      state: newState
    }, { conflict: 'replace' }).run(q.queryRunOptions);
  }).then(function (insertResult) {
    logger('insertResult', insertResult);
    return true;
  });
};